# FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
# License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
# Author: Sergey Cheremukhin

###############################################################################
# Find KLT
#
# This sets the following variables:
# KLT_FOUND - True if FLANN was found.
# KLT_INCLUDE_DIR - Directories containing the FLANN include files.

set(KLT_FILE_PATH ${PROJECT_SOURCE_DIR}/../thirdparty/klt)
set(KLT_FILE selectGoodFeatures.c)
find_path(KLT_INCLUDE_DIR NAMES ${KLT_FILE} PATHS ${KLT_FILE_PATH})

message(STATUS "Found KLT? " ${KLT_INCLUDE_DIR})
message(STATUS "KLT_FILE? " ${KLT_FILE})

set(KLT_FOUND "NO")

if(KLT_INCLUDE_DIR)
	set(KLT_FOUND "YES")
	if(NOT KLT_FIND_QUIETLY)
		message(STATUS "Found KLT: " ${KLT_INCLUDE_DIR})
	endif(NOT KLT_FIND_QUIETLY)
else(KLT_INCLUDE_DIR)
	message(STATUS "klt option? " ${DOWNLOAD_KLT})
	execute_process( COMMAND sh getklt.sh WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/../thirdparty)
	find_path(KLT_INCLUDE_DIR ${KLT_FILE} ${KLT_FILE_PATH})
	if(KLT_INCLUDE_DIR)
	        set(KLT_FOUND "YES")
	        if(NOT KLT_FIND_QUIETLY)
	                message(STATUS "Found KLT: " ${KLT_INCLUDE_DIR})
	        endif(NOT KLT_FIND_QUIETLY)
	endif( KLT_INCLUDE_DIR )
endif( KLT_INCLUDE_DIR )

message(STATUS "Found KLT? " ${KLT_FOUND})

mark_as_advanced(KLT_INCLUDE_DIR)
mark_as_advanced(KLT_FOUND)

