

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "drawing.h"

namespace adore
{

	namespace core
	{

		LineIterator::LineIterator( int x0, int y0, int x1, int y1 ):
				x( 0 ), y( 0 ),
				dx( 0 ),
				dy( 0 ),
				stepx( 0 ), stepy( 0 )
		{
			init( x0, y0, x1, y1 );
		}

		void LineIterator::init( int x0, int y0, int x1, int y1 )
		{
			x = x0; y = y0;
			dy = y1 - y0;
			dx = x1 - x0;

			if ( dy < 0 )
			{
				dy = -dy;  stepy = -1;
			}
			else
			{
				stepy = 1;
			}
			if ( dx < 0 )
			{
				dx = -dx;  stepx = -1;
			}
			else
			{
				stepx = 1;
			}
			dy <<= 1;// dy is now 2*dy
			dx <<= 1;// dx is now 2*dx

			if ( dx > dy )
			{
				fraction = dy - ( dx >> 1 ); done = ( x == x1 ); stop = x1;
			}
			else
			{
				fraction = dx - ( dy >> 1 ); done = ( y == y1 ); stop = y1;
			}
		}

		void LineIterator::next()
		{
			if ( done ) return;
			if ( dx > dy )
			{
				if ( fraction >= 0 )
				{
					y += stepy;
					fraction -= dx;                   // same as fraction -= 2*dx
				}
				x += stepx;
				fraction += dy;                      // same as fraction -= 2*dy
				done = ( x == stop );
			}
			else
			{
				if ( fraction >= 0 )
				{
					x += stepx;
					fraction -= dy;
				}
				y += stepy;
				fraction += dx;
				done = ( y == stop );
			}
		}

	}
}
