

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_MINIMIZATIONDEFAULTERRORFUNC_H
#define ADORE_MINIMIZATIONDEFAULTERRORFUNC_H

#include <adrcore/types/aarray.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		template<class T_numtype>
		class DefaultErrorFunc
		{
			public:
				DefaultErrorFunc( AArray<T_numtype, 1> &goal ):g( goal )
				{
				}

				~DefaultErrorFunc()
				{
				}

				AVector operator()( AArray<T_numtype, 1> &val ) const
				{
					return val - g;
				}

				void operator()( AArray<T_numtype, 1> &val, AVector& result ) const
				{
					result = val - g;
				}

			private:
				AArray<T_numtype, 1> &g;
		};

		template<class T_numtype>
		class ZeroErrorFunc
		{
			public:
				ZeroErrorFunc()
				{
				}

				~ZeroErrorFunc()
				{
				}

				AArray<T_numtype, 1> &operator()( AArray<T_numtype, 1> &val ) const
				{
					return val;
				}

				void operator()( AArray<T_numtype, 1> &val, AArray<T_numtype, 1>& res ) const
				{
					res = val;
				}

			private:

		};


	}

}

#endif
