

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_COREAUTOMERGER_H
#define ADORE_COREAUTOMERGER_H

#include "merger.h"
#include "badpointremover.h"
#include <adrcore/nview/baprojective.h>

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		class AutoMerger
		{
			private:
				Merger merger;
				BadPointRemover2 bpr2;//repro err
//				BadPointRemover3 bpr3;//in front of cams
				BAProjectiveSimple ba;

			public:
				AutoMerger( double reproThresh ):bpr2( reproThresh )
				{
					merger.setMinimizeReproErr( true );
					merger.setUseCameras ( true );
					merger.setUsePoints3D ( false );
				}

				/**
					@param delSourceNViews if true, the nviews that were merged
					get deleted and only the result prevails
				*/
				bool merge ( NViewMap &nviewmap, ViewKnitter &knit, const bool delSourceNViews = false );
		};

	}

}

#endif
