

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_NVIEWFEATUREPOINTFILTERFMAT_H
#define ADORE_NVIEWFEATUREPOINTFILTERFMAT_H

#include <adrcore/nview/nviewoperator.h>

namespace adore
{

	namespace core
	{


		/**
			Unlike FeaturePointFilter this one uses an already computed fmat instead of invoking ransac
			 
		*/
		class FeaturePointFilterFMat : public NViewOperator
		{
			private:
				double thresh;

			public:
				FeaturePointFilterFMat( float threshold = 2.0 ):
						thresh( threshold )
				{
					;
				}

				~FeaturePointFilterFMat()
				{
					;
				}

				void modify( NView &nview )
				{
					switch ( nview.getNumViews() )
					{
						case 2:
							modify2( nview );
							break;
						default:
							error( "unsupported number of views\n" );
							break;
					}
				}

			private:
				void modify2( NView &nview );

		};



	}
}

#endif
