

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_PARAMETERIZATIONCONSTANTS_H
#define ADORE_PARAMETERIZATIONCONSTANTS_H


namespace adore
{

	namespace core
	{

		enum CALIBRATION_ENTITY
		{
			FL = 0,
			AR = 1,
			SKEW = 2,
			PPX = 3,
			PPY = 4
		};
		const int numCalibrationEntities = 5;
		const int maxCalibrationEntityValue = 4;

		enum PARAMETER_TYPE
		{
			HARD = 0, //set for every camera
			HARD_CONST = 1, //all cameras have the same known
			FREE = 2,    //every camera has an own, unknown value
			FREE_CONST = 3,  //all cameras have the same, but unknown
			SOFT = 4,    //every cam has an own, known value, to which an uncertainty is attached
			SOFT_CONST = 5  //all cams have the same, known value, to which an uncertainty is attached
		};
		const int numParameterTypes = 6;
		const int maxParameterTypeValue = 5;


	}
}

#endif

