

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_PARAMETERIZATIONZFIXEDPOINTPARAM_H
#define ADORE_PARAMETERIZATIONZFIXEDPOINTPARAM_H

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		class ZFixedPointParam
		{
			public:
				ZFixedPointParam()
				{
					;
				}

				~ZFixedPointParam()
				{
					;
				}

				int getSize()
				{
					return 3;
				}

                void fromParam( const vector<AVector> &param, vector<AVector3D*> &pts ) const
				{
					for ( uint i = 0; i < param.size(); ++i ) //param.size is the limiting factor, as
						//excess cameras may be trated as fixed ones
					{
                        fromParam( param[i], *pts[i] );
					}
				}

                void toParam( const vector<AVector3D*> &pts, vector<AVector> &param ) const
				{
					assert( pts.size() >= param.size() );

					for ( uint i = 0; i < param.size(); ++i ) //param.size is the limiting factor, as
						//excess cameras may be trated as fixed ones
					{
//						printf( "%u of (%u, %u)\n", i, pts.size(), param.size() );
                        toParam( *pts[i], param[i] );
					}
				}

				void fromParam( const AVector &param, AVector3D &pts ) const
				{
					pts( 0 ) = param( 0 );
					pts( 1 ) = param( 1 );
					pts( 2 ) = 1.0;
					pts( 3 ) = param( 2 );
				}

				void toParam( const AVector3D &pts, AVector &param ) const
				{
					double z = pts( 2 );
					assert_msg( z != 0.0, "point was (%f, %f, %f, %f)\n", pts( 0 ), pts( 1 ), pts( 2 ), pts( 3 ) );
					param( 0 ) = pts( 0 ) / z;
					param( 1 ) = pts( 1 ) / z;
					param( 2 ) = pts( 3 ) / z;
				}


		};

	}

}

#endif
