

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_CORENVIRANSACCLIENT_H
#define ADORE_CORENVIRANSACCLIENT_H

#include "ransacclient.h"
#include <adrcore/types/nview.h>

namespace adore
{

	namespace core
	{

		class NViewInfo;
		class NView;

		/**
		 * A ransac client that additionally creates an NVInfo
			 
		*/
		class NVIRANSACClient : public RANSACClient
		{
			public:
				typedef vector<int> InlierCollT;
				typedef InlierCollT::iterator iterator;

			public:
				NVIRANSACClient():RANSACClient()
				{
					;
				}

				NVIRANSACClient( const NVIRANSACClient &rc ):RANSACClient( rc )
				{
					;
				}

				virtual NVIRANSACClient *clone()
				{
					error( "missing implementation\n" );
				}

				virtual ~NVIRANSACClient()
				{
					;
				}

				virtual void init( NView::CorrIterator it, int size, NView::ViewIterator vit ) = 0;

				virtual NViewInfo *createNViewInfo() = 0;

				virtual iterator begin() = 0;

				virtual iterator end() = 0;

				virtual PointCorr *getPointCorr( int i ) = 0;

				virtual int getModelType() const = 0;

				virtual double getThreshold() const = 0;

				virtual void setThreshold( double ) = 0;
		};

	}

}

#endif
