

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_CORERANSACPARAMS_H
#define ADORE_CORERANSACPARAMS_H

#include <utility>
#include <vector>

namespace adore
{

	namespace core
	{

		/**
			 
		*/

		class RansacParams
		{

			private:
				int numIterations;
				float probability;

			public:
				RansacParams ( int n, float prob = 0.99 ) :numIterations ( n ), probability ( prob ) {}

				void setNumIterations ( int theValue )
				{
					numIterations = theValue;
				}

				int getNumIterations() const
				{
					return numIterations;
				}

				void setProbability ( float theValue )
				{
					probability = theValue;
				}

				float getProbability() const
				{
					return probability;
				}

		};

		extern RansacParams DefaultRansacParams;
		extern RansacParams DefaultHighRansacParams;
		extern RansacParams DefaultLowRansacParams;

		class NVIRANSACClient;
		typedef std::pair<NVIRANSACClient*, RansacParams> ClientAndParams;
		typedef std::vector<ClientAndParams> ClientList;

	}

}

#endif
