

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ADORE_AARRAYINITIALIZER_H
#define ADORE_AARRAYINITIALIZER_H

namespace adore {
namespace core {

template <typename A> class Initializer
{
    typedef typename A::scalar_type scalar_type;
    typedef typename A::iterator iterator;

    scalar_type m_last_val;
	iterator m_it, m_end;

public:
    Initializer(A& arr, const scalar_type v) :
		m_last_val(v), m_it(arr.begin()), m_end(arr.end())
	{
		*m_it = m_last_val;
		++m_it;
	}

    Initializer& operator,(const scalar_type v)
    {
        m_last_val = v;
		*m_it = v; ++m_it;
        return *this;
    }

    ~Initializer()
    {
		for( ; m_it != m_end; ++m_it)
			*m_it = m_last_val;
    }
};

} // core
} // adore

#endif // ADORE_AARRAYINITIALIZER_H
