

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_COREASTACK_H
#define ADORE_COREASTACK_H

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		template<class T>
		class AStack
		{
			public:
				AStack( uint size ):
						data( new T[size] ),begin( &data[0] ), end( begin + size ), loc( begin )
				{;}

				~AStack() {delete [] data;}

				void push( const T &elem )
				{
					assert( loc != end );
					*loc++ = elem;
				}

				T &top()
				{
					assert( loc != begin );
					return *( loc - 1 );
				}

				const T &top() const
				{
					assert( loc != begin );
					return *( loc - 1 );
				}

				void pop()
				{
					assert( loc != begin );
					--loc;
				}

				bool empty() const
				{
					return loc == begin;
				}

				uint size() const
				{
					return loc - begin;
				}

				uint capacity() const
				{
					return end - begin;
				}

			private:
				T* data;
				T* begin;
				T* end;
				T* loc;
		};

	}

}

#endif
