

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_CORENUMERATOR_H
#define ADORE_CORENUMERATOR_H

namespace adore
{

	namespace core
	{

		/**
			 
		*/
		template <class T>
		class Numerator
		{
			public:
				Numerator( T start = 0 ):lastNum( start )
				{
				}

				~Numerator() {;}

				uint operator()()
				{
					return lastNum++;
				}

				T query() const
				{
					return lastNum;
				}

				void atLeast( T val )
				{
					lastNum = lastNum < val ? val : lastNum;
				}

			private:
				T lastNum;
		};

	}

}

#endif
