

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_CANNYFINDER_H
#define ADORE_CANNYFINDER_H


#include "featurefinder.h"
#include <adrcore/imgprocessing/imageplane.h>
#include <adrcore/imgprocessing/templatematching.h>
#include <adrcore/types/featurepoint.h>
#include <adrcore/types/view.h>



namespace adore
{
	namespace core
	{

		class CannyFinder : public FeatureFinder
		{

			protected:
				typedef View<uint8_t> ViewT;
				typedef uint8_t imgT;
				typedef int ouT;

			private:
				uint fid;//feature id
				float minDist, minFraction;
				ouT minStrength;
				int maxPoints;
				uint cannyHood;
				ImagePlane<ouT> gxx;
				ImagePlane<ouT> gyy;
				ImagePlane<ouT> gxy;
				//for canny features
				ImagePlane<ouT> mag;
				ImagePlane<uint8_t> sec;
				ImagePlane<uint8_t> cImg;

			public:
				CannyFinder ( uint ID = 0,
				              uint cHood = 3,
				              float mindist = 5.0,
				              ouT minstrength = 1000,
				              float minfraction = 0.002,
				              int maxpoints = INT_MAX );

				CannyFinder( const CannyFinder &cf );

				FeatureFinder *clone() {return new CannyFinder( *this );}

			protected:
				unsigned int findFeaturesDerived ( ViewT *v );

			private:
				void calcDizenzo ( ImagePlane<imgT> &img );

		};
	}
}//ns

#endif
