

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef ADORE_CORE_LINESFILTERINGMERGER_H
#define ADORE_CORE_LINESFILTERINGMERGER_H

#include <adrcore/types/aarray.h>

namespace adore
{
	namespace core
	{

		class NView;
		class NViewMap;
		class FeatureLine;

		class LinesFilteringMerger
		{
			public:
				LinesFilteringMerger( double thresh = 0.8 );

				void merge( NViewMap& nviewmap );
				void mergeLines( NView* nv1, NView* nv2, NView* set );

			private:
				double threshold;

				void toLine( FeatureLine* fl, AVector& l );
				void transfer23_1( const AVector& l2, const AVector& l3, const ATensor3& tt, AVector& l1 );
				double distance( double x1, double y1, double x2, double y2, double px, double py );
		};

	}
}

#endif // ADORE_CORE_LINESFILTERINGMERGER_H
