

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#ifndef ADORE_CORESEQUENCEVIEWRELATER_H
#define ADORE_CORESEQUENCEVIEWRELATER_H

#include "viewrelater.h"

namespace adore
{

	namespace core
	{

		/**
		 * This knitter creates a set of NViews that fit a sequence of views
			 
		*/
		class SequenceViewRelater : public ViewRelater
		{
			private:
				bool closed;

			public:
				SequenceViewRelater ( bool closedSequence = false ):closed ( closedSequence ) {;}

				void createRelations ( ViewBase **vit, int numViews, ViewRelations &vrela )
				{
					if ( numViews < 2 ) return;

					int done = 1;
					int vidx0 = 0, vidx1 = vrela.addView( *vit );	++vit;
					int start = vidx1;//in case of closed sequence
					do
					{
						vidx0 = vidx1;
						vidx1 = vrela.addView( *vit );
						vrela.setNeighbors ( vidx0, vidx1, true );
						++vit; ++done;
					}
					while ( done < numViews );
					if ( closed )
					{
						vrela.setNeighbors ( vidx1, start, true );
					}
				}

		};

	}

}

#endif
