

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#ifndef ADORE_GLLIGHT_H
#define ADORE_GLLIGHT_H

#include "glmath.h"

namespace adore
{
	namespace visual
	{
		/**	Contains render states for adding light sources to the scene
		 *
		 *	 
		 */
		class GLLight
		{
		public:
			Vector4D position;		///< light position

			Vector4D ambient;		///< ambient color
			Vector4D diffuse;		///< diffuse color
			Vector4D specular;		///< specular color

			Vector4D spot;			///< light direction
			float spot_exp;			///< spot exponent
			float spot_cutoff;		///< spot cutoff, in degrees

			float att_const;		///< constant attenuation
			float att_linear;		///< linear attenuation
			float att_quad;			///< quadratic attenuation

			bool enabled;			///< light is enabled

			/**	Constructor
			 */
			GLLight();

			/**	Set OpenGL light properties
			 *	@param index Light index, can vary from 0 to 9
			 */
			void setOpenGLLight(int index);
		};
	}
}

#endif	// ADORE_GLLIGHT_H
