

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Andrei Tchouev


#include "glmaterial.h"

#include <GL/gl.h>

namespace adore
{
	namespace visual
	{
		GLMaterial::GLMaterial()
		{
			smooth = true;
			wireframe = false;
			depth = true;
			cull = false;

			ambient.set(0.2f,0.2f,0.2f,1.0f);
			diffuse.set(0.8f,0.8f,0.8f,1.0f);
			specular.set(0.0f,0.0f,0.0f,1.0f);
			shininess = 0;
		}

		void GLMaterial::setOpenGLMaterial()
		{
			if(smooth)
				glShadeModel(GL_SMOOTH);
			else
				glShadeModel(GL_FLAT);

			if(wireframe)
				glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
			else
				glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

			if(depth)
			{
				glEnable(GL_DEPTH_TEST);
				glDepthFunc(GL_LESS);
			}
			else
				glDisable(GL_DEPTH);

			if(cull)
			{
				glEnable(GL_CULL_FACE);
				glCullFace(GL_BACK);
			}
			else
				glDisable(GL_CULL_FACE);

			glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,ambient.toArray());
			glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,diffuse.toArray());
			glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,specular.toArray());
			glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,shininess);
		}
	}
}
