

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "itemrenderer.h"
#include <adrcore/util/debug.h>

namespace adore {
namespace visual {

        ItemRenderer::ItemRenderer()
        {
        }
        
        
        ItemRenderer::~ItemRenderer()
        {
        }
        
        void ItemRenderer::init()
        {
        }
        
        void ItemRenderer::focus()
        {
            camera.setOpenGLProjection();
        }
        
        void ItemRenderer::unfocus()
        {
        }
                
        void ItemRenderer::paint()
        {
            glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

            camera.setOpenGLModelView();
            
//             DBGOUT(DBGNORMAL, "ItemRenderer: rendering %d items\n", items.size());
            
            for(uint i = 0; i < items.size(); ++i)
            {
                items[i]->render();
            }
        }
        
        void ItemRenderer::resize(int width, int height)
        {
            glViewport(0,0,width,height);
        }
        
        void ItemRenderer::pick(int x, int y)
        {
            
        }
        

        void ItemRenderer::perspective(float fov, float aspect, float nplane, float fplane)
        {
            camera.perspective(fov,aspect,nplane,fplane);//set the parameter
            camera.setOpenGLProjection();//and update the view
        }

        void ItemRenderer::lookAt(const float eye[3], const float aim[3], const float up[3])
        {
            DBGOUT(DBGNORMAL, "ItemRenderer: setting camera to eye(%f, %f, %f)-aim(%f, %f, %f)-up(%f, %f, %f)\n", 
                   eye[0],eye[1],eye[2],aim[0],aim[1],aim[2],up[0],up[1],up[2]);
            
            camera.set(Vector3D(eye[0],eye[1],eye[2]),Vector3D(aim[0],aim[1],aim[2]),Vector3D(up[0],up[1],up[2]));
        }
        
        void ItemRenderer::lookAt(const adore::core::AVector &eye, const adore::core::AVector &aim, const adore::core::AVector &up)
        {
            camera.set(Vector3D(eye(0),eye(1),eye(2)),Vector3D(aim(0),aim(1),aim(2)),Vector3D(up(0),up(1),up(2)));
        }

        void ItemRenderer::roll(float angle)
        {
            camera.roll(angle);
        }

        void ItemRenderer::yaw(float angle)
        {
            camera.yaw(angle);
        }

        void ItemRenderer::pitch(float angle)
        {
            camera.pitch(angle);
        }
        
        void ItemRenderer::turn(float angle)
        {
            camera.turn(angle);
        }

        void ItemRenderer::tilt(float angle, float gap)
        {
            camera.tilt(angle,gap);
        }

        void ItemRenderer::slide(const float delta[3])
        {
            camera.slide(Vector3D(delta[0],delta[1],delta[2]));
        }


}}
