

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include <QtGui/QLineEdit>
#include <QtGui/QDoubleValidator>

#include <limits>

#include "camerawidget.h"

CameraWidget::CameraWidget( QWidget* parent ) : QWidget( parent )
{
	ui.setupUi( this );

	beautifyLineEdit(ui.flx);
	beautifyLineEdit(ui.skew);
	beautifyLineEdit(ui.px);
	beautifyLineEdit(ui.fly);
	beautifyLineEdit(ui.py);

	beautifyLineEdit(ui.r00);
	beautifyLineEdit(ui.r01);
	beautifyLineEdit(ui.r02);
	beautifyLineEdit(ui.r10);
	beautifyLineEdit(ui.r11);
	beautifyLineEdit(ui.r12);
	beautifyLineEdit(ui.r20);
	beautifyLineEdit(ui.r21);
	beautifyLineEdit(ui.r22);

	beautifyLineEdit(ui.rx);
	beautifyLineEdit(ui.ry);
	beautifyLineEdit(ui.rz);
	beautifyLineEdit(ui.angle);

	beautifyLineEdit(ui.posx);
	beautifyLineEdit(ui.posy);
	beautifyLineEdit(ui.posz);

	adjustSize();
}

void CameraWidget::beautifyLineEdit(QLineEdit* l)
{
	QFontMetrics fm(l->font());
	int w = fm.width("-0.00000") + 16;
	l->setMaximumWidth(w);
	l->setValidator( new QDoubleValidator(std::numeric_limits<double>::min(), std::numeric_limits<double>::max(), 5, l) );
}

CameraWidget::~CameraWidget() {}

