

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#include "checkbuttongl.h"

CheckButtonGL::CheckButtonGL(const QString& text) :
		m_checked(false),
		m_label0(text),
		m_label1(text)
{
}

void CheckButtonGL::initialize(QGLWidget* binder)
{
	m_label0.buildTexture(0xff00aa40, binder);
	m_label1.buildTexture(0xff00ff80, binder);
	double w = std::max(m_label0.width(), m_label1.width());
	double h = std::max(m_label0.height(), m_label1.height());
	size = QSizeF(w, h);
}

void CheckButtonGL::cleanup()
{
	m_label0.releaseTexture();
	m_label1.releaseTexture();
}

void CheckButtonGL::paint() const
{
	glTranslated(position.x(), position.y(), 0.0);
	if(m_checked) m_label1.draw();
	else m_label0.draw();
	glTranslated(-position.x(), -position.y(), 0.0);
}

void CheckButtonGL::click(double, double)
{
	m_checked = !m_checked;
	emit toggled(this, m_checked);
}
