

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef CHECKBUTTONGL_H
#define CHECKBUTTONGL_H

#include <QtCore/QString>

#include "buttongl.h"
#include "textlabelgl.h"

class QGLWidget;

class CheckButtonGL : public ButtonGL
{
public:
	CheckButtonGL(const QString& text);

	void initialize(QGLWidget* binder);
	void cleanup();

	bool getState() const { return m_checked; }
	void setState(bool checked) { m_checked = checked; }

	void paint() const;

protected:
	void click(double x, double y);
	void beginDragging(double, double) {}
	void drag(double, double) {}

private:
	bool m_checked;
	TextLabelGL m_label0, m_label1;
};

#endif // CHECKBUTTONGL_H
