

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef CONTROLGL_H
#define CONTROLGL_H

#include <QObject>

#include "item2d.h"

class QGLWidget;

class ControlGL : public QObject, public Item2d
{
	Q_OBJECT

	enum { ClickInterval = 400, MaxClickDeviation = 2 };

public:
	ControlGL();
	virtual ~ControlGL() {}

	virtual void initialize(QGLWidget* binder) = 0;
	virtual void cleanup() = 0;

	virtual void pressed(double x, double y);
	virtual void released(double x, double y);
	virtual void moved(double x, double y);

protected:
	virtual void click(double x, double y) = 0;
	virtual void beginDragging(double x, double y) = 0;
	virtual void drag(double dx, double dy) = 0;

private:
	bool m_is_pressed, m_is_dragging;
	QPointF m_last_point;
};

#endif // CONTROLGL_H
