

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef CORRLAYERITEM_H
#define CORRLAYERITEM_H

#include "item2d.h"

#include <GL/gl.h>

#include <vector>
#include <boost/shared_ptr.hpp>

namespace adore
{
	namespace core
	{
		class NView;
		class PointCorr;
		class ViewBase;
	}
}

class PixmapPlane;

class CorrLayerItem : public Item2d
{
	public:
		typedef boost::shared_ptr<PixmapPlane> ImagePtr;
		CorrLayerItem( adore::core::NView* nv, const std::vector<ImagePtr>& images );
		~CorrLayerItem();
		void setPointCorrsVisible( bool on ) { pCorrsVisible = on; }
		void setLineCorrsVisible( bool on ) { lCorrsVisible = on; }

		virtual void paint() const;

	private:
		adore::core::NView* nview;
		GLuint pointCorrsList, lineCorrsList;
		bool pCorrsVisible, lCorrsVisible;

		void createContent( const std::vector<ImagePtr>& images );

		void drawLineGl( const QPointF& p0, const QPointF& p1, double thickness );
};

#endif //CORRLAYERITEM_H
