

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef EXCLUSIVEOPTIONSGROUP_H
#define EXCLUSIVEOPTIONSGROUP_H

#include <QObject>

#include <string>
#include <map>

class ButtonGL;
class CheckButtonGL;

class ExclusiveOptionsGroup : public QObject
{
	Q_OBJECT
public:
	ExclusiveOptionsGroup() {}

	void addOption(CheckButtonGL * option, const std::string& optionId);

	void activateOption(const std::string& name);
	const std::string& activeOption() const;

signals:
	void sigOptionActivated(const std::string& name);

private:
	typedef std::map<std::string, CheckButtonGL*> OptionsT;
	OptionsT m_options;
	typedef std::map<CheckButtonGL*, std::string> OptionsInvMapT;
	OptionsInvMapT m_options_names;

private slots:
	void optionActivated(ButtonGL * option);
};

#endif // EXCLUSIVEOPTIONSGROUP_H
