

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef FEATURESLAYER_H
#define FEATURESLAYER_H

#include "item2d.h"

#include <vector>

#include <GL/gl.h>

#include "constants.h"

using std::vector;
using adore::core::View;

class QGLWidget;

class FeaturesLayer : public Item2d
{
	public:
		FeaturesLayer( ViewT* v, bool listm = false );
		~FeaturesLayer();
		void updateFeatures();
		void setFeaturesVisible( bool on ) { featuresVisible = on; }
		void setLinesVisible( bool on ) { linesVisible = on; }

		virtual void paint() const;

	private:
		ViewT* view;
		bool listMode;
		GLuint feature, featList, lineList;
		bool featuresVisible, linesVisible;

		struct xy { xy( float xx, float yy ) : x( xx ), y( yy ) {} float x, y; };
		vector<xy> offsets;
		GLuint glMakeFeatureList() const;
		void glDrawRect( float x, float y, float width, float height ) const;
};

#endif // FEATURESLAYER_H
