

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef SCROLLBARGL_H
#define SCROLLBARGL_H

#include "controlgl.h"

class ScrollBarGL : public ControlGL
{
	Q_OBJECT
	enum { Border = 8, Margin = 2, SliderWidth = 16, Thickness = 20 };

public:
	enum Type { Horizontal, Vertical };
	ScrollBarGL(Type t);

	void initialize(QGLWidget* binder);
	void cleanup() {}

	void paint() const;

	void resize( const QRectF& viewport, const QRectF& content );

	double getPos() const { return m_content_min + m_pos * m_factor; }

	void move( double delta );

signals:
	void positionChanged(double);

protected:
	void click(double x, double y);
	void beginDragging(double, double);
	void drag(double, double);

private:
	Type m_type;
	double m_content_min, m_max, m_pos, m_factor;
	double m_slider_length;
};

#endif // SCROLLBARGL_H
