

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Sergey Cheremukhin


#ifndef SLIDERGL_H
#define SLIDERGL_H

#include "controlgl.h"

class SliderGL : public ControlGL
{
	Q_OBJECT

	enum { Margin = 2, SliderWidth = 16, SliderLength = 24, Thickness = 20 };

public:
	enum Type { Horizontal, Vertical };
	SliderGL(Type t, int min, int max);

	void initialize(QGLWidget* binder);
	void cleanup() {}

	void paint() const;

	void setLength(double len);

	void setValue(int val);

	void move( double delta );

signals:
	void valueChanged(int);

protected:
	void click(double x, double y);
	void beginDragging(double, double);
	void drag(double, double);

private:
	Type m_type;
	int m_min, m_max, m_pos;
};

#endif // SLIDERGL_H
