

/// FernUniversität in Hagen, Lehrgebiet Mensch-Computer-Interaktion
/// License: Creative Commons Attribution-Noncommercial-Share Alike 3.0  Germany, see README file that comes with this work
/// Author: Klaus Haeming


#include "tensortrafo.h"

namespace adore
{

	namespace core
	{

//		currently it is exploited that these matrices are upper triangle
//		the inverse trafos are calculated
		ATensor3 transformT( const ATensor3 & tensor, const AMatrix & A, const AMatrix & Binv, const AMatrix & Cinv )
		{
			ATensor3 destTensor( 3, 3, 3 );

			for ( int i = 0; i < 3; ++i ) for ( int j = 0; j < 3; ++j ) for ( int k = 0; k < 3; ++k )
					{
						destTensor( i, j, k ) = 0.0;

						for ( int r = 0; r <= i; ++r ) for ( int s = j; s < 3; ++s ) for ( int t = k; t < 3; ++t )
								{
									destTensor( i, j, k ) += A( r, i ) * Binv( j, s ) * Cinv( k, t ) * tensor( r, s, t );
								}
					}

			//destTensor.normalizeExponents();//OPT
			return destTensor;
		}

		void transform( ATensor3 & tensor, const AMatrix & A, const AMatrix & Binv, const AMatrix & Cinv )
		{
			ATensor3 temp( tensor/*.copy()*/ );
			for ( int i = 0; i < 3; ++i ) for ( int j = 0; j < 3; ++j ) for ( int k = 0; k < 3; ++k )
					{
						tensor( i, j, k ) = 0.0;

						for ( int r = 0; r <= i; ++r ) for ( int s = j; s < 3; ++s ) for ( int t = k; t < 3; ++t )
								{
									tensor( i, j, k ) += A( r, i ) * Binv( j, s ) * Cinv( k, t ) * temp( r, s, t );
								}
					}

			//tensor.normalizeExponents();//OPT
		}

		ATensor3 transformT( const AVector & lineTensor, const AMatrix & A, const AMatrix & Binv, const AMatrix & Cinv )
		{
			ATensor3 destTensor( 3, 3, 3 );
			for ( int i = 0; i < 3; ++i ) for ( int j = 0; j < 3; ++j ) for ( int k = 0; k < 3; ++k )
					{
						destTensor( i, j, k ) = 0.0;

						for ( int r = 0; r <= i; ++r ) for ( int s = j; s < 3; ++s ) for ( int t = k; t < 3; ++t )
								{
									destTensor( i, j, k ) += A( r, i ) * Binv( j, s ) * Cinv( k, t ) * lineTensor( r * 9 + s * 3 + t );
								}
					}

			//destTensor.normalizeExponents();//OPT
			return destTensor;
		}

		AVector transformV( const AVector & lineTensor, const AMatrix & A, const AMatrix & Binv, const AMatrix & Cinv )
		{
			AVector destLineTensor( 27 );
			int coor = 0;
			for ( int i = 0; i < 3; ++i ) for ( int j = 0; j < 3; ++j ) for ( int k = 0; k < 3; ++k )
					{
						destLineTensor( coor ) =  0.0;

						for ( int r = 0; r <= i; ++r ) for ( int s = j; s < 3; ++s ) for ( int t = k; t < 3; ++t )
								{
									destLineTensor( coor ) = destLineTensor( coor ) + A( r, i ) * Binv( j, s ) * Cinv( k, t ) * lineTensor( r * 9 + s * 3 + t );
									++coor;
								}
					}

			//normalizeExponents(destLineTensor);//OPT
			return destLineTensor;
		}


	}

}
